"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var types_1 = require("@babel/types");
function default_1() {
    return {
        visitor: {
            TemplateLiteral: function (path) {
                if ((0, types_1.isTemplateLiteral)(path.node)) {
                    var leadingComments = path.node.leadingComments;
                    if (leadingComments) {
                        var isCSS = leadingComments[leadingComments.length - 1].value
                            .trim()
                            .toLowerCase() === "css";
                        if (isCSS) {
                            var names = path.node.quasis
                                .flatMap(function (_a) {
                                var value = _a.value;
                                return value.raw.match(/[.#][A-Za-z_-][A-Za-z0-9_-]*/g) || [];
                            })
                                .reduce(function (acc, x) { return (acc.includes(x) ? acc : __spreadArray(__spreadArray([], acc, true), [x], false)); }, []);
                            path.replaceWithSourceString("\"/*extracted*/ ".concat(names.join(" "), "\""));
                        }
                    }
                }
            },
        },
    };
}
exports.default = default_1;
